// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2005                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
// 
//
// 쐬 : K.Yakushinji
//    : 2005/08/08 
//
//-------------------------------------------------------------------

// Histgram.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "histogram.h"
#include "Histgram.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define MAX_DENSITY 256

/////////////////////////////////////////////////////////////////////////////
// CHistgram _CAO


CHistgram::CHistgram(CWnd* pParent /*=NULL*/)
	: CDialog(CHistgram::IDD, pParent)
{

	//f[^̏
	ZeroMemory(m_lHistogram, sizeof(m_lHistogram));

	// Ot`͈
	m_GraphRect.left = 10;
	m_GraphRect.top = 10;
	m_GraphRect.right = m_GraphRect.left + MAX_DENSITY;
	m_GraphRect.bottom  = m_GraphRect.top + 200;
	
	//{{AFX_DATA_INIT(CHistgram)
	//}}AFX_DATA_INIT
}


void CHistgram::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHistgram)
	DDX_Control(pDX, IDC_STATIC_MAX, m_Max);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CHistgram, CDialog)
	//{{AFX_MSG_MAP(CHistgram)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHistgram bZ[W nh

void CHistgram::OnPaint() 
{
	CPaintDC dc(this); // `p̃foCX ReLXg
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	// `掞̂}邽߁Aobt@gp

	CRect rect;
	CBitmap bitmap;
	CDC memDC;

	GetClientRect(&rect);	//EBhȆ傫擾

	//Rp`u(݊̂)ȃrbg}bv擾()
	bitmap.CreateCompatibleBitmap(&dc, rect.Width(), rect.Height());
	//Rp`u(݊̂)ȃrbg}bṽfoCXReLXg(CDC)擾
	memDC.CreateCompatibleDC(&dc);
	memDC.SelectObject(&bitmap);

	// {^\ʂ̃VXeJ[œhԂ
	memDC.FillSolidRect(rect,GetSysColor(COLOR_3DFACE));

	/*	ʂɕ` */
	MyOnPaint( &memDC );

	//ʂɏrbg}bv\ʂɃRs[
	dc.BitBlt(0, 0, rect.Width(), rect.Height(), &memDC, 0, 0, SRCCOPY);

	memDC.DeleteDC();
	bitmap.DeleteObject();
	
}

// qXgOl̃Zbg
void CHistgram::SetData(int nDensity, long lNum)
{
	if( 0 <= nDensity && nDensity < MAX_DENSITY ){
		lNum = (lNum > 0) ? lNum : 0;
		m_lHistogram[nDensity] = lNum;
	}
}

// obt@ւ̕`
void CHistgram::MyOnPaint(CDC *pDC)
{
	CBrush blackBrush;
	CPen *pOldPen, *pNewPen;
	CString strBuff;
	RECT rc_frame;
	int i;
	long lMax,lNum;

	blackBrush.CreateSolidBrush( RGB( 128,128,128 ) );

	// Otg
	rc_frame.left = m_GraphRect.left-1;
	rc_frame.top = m_GraphRect.top-1;
	rc_frame.right = m_GraphRect.right+3;
	rc_frame.bottom = m_GraphRect.bottom+3;

	pDC->FrameRect( &rc_frame, pDC->GetCurrentBrush() );
	rc_frame.left-=1; rc_frame.top-=1;
	rc_frame.right-=1; rc_frame.bottom-=1;
	pDC->FrameRect( &rc_frame, &blackBrush );
	
	// ZxlOf[Vg
	rc_frame.left = m_GraphRect.left-1;
	rc_frame.top = m_GraphRect.bottom+10-1;
	rc_frame.right = m_GraphRect.right+3;
	rc_frame.bottom = m_GraphRect.bottom+20+3;

	pDC->FrameRect( &rc_frame, pDC->GetCurrentBrush() );
	rc_frame.left-=1; rc_frame.top-=1;
	rc_frame.right-=1; rc_frame.bottom-=1;
	pDC->FrameRect( &rc_frame, &blackBrush );

	// ZxlOf[V
	for(i=0;i<MAX_DENSITY;i++){
		pNewPen = new CPen( PS_SOLID, 1, RGB(i,i,i) );
		pOldPen = pDC->SelectObject(pNewPen);

		pDC->MoveTo( m_GraphRect.left + i, m_GraphRect.bottom + 10 );
		pDC->LineTo( m_GraphRect.left + i, m_GraphRect.bottom + 20 );
		delete pDC->SelectObject(pOldPen);
	}

	// ől߂āAOtōőɕ\悤ɃXP[OB
	// A00xff̓Nbvꂽlő傫Ȃ̂ŁA
	// XP[ȎΏۂ͂Ă
	lMax = m_lHistogram[0];
	for(i=1 ;i<MAX_DENSITY-1; i++){
		if(lMax < m_lHistogram[i]) lMax = m_lHistogram[i];
	}
	//ʑŜS0x0(^) or 0xff(^)̏ꍇ
	if(0 == lMax) lMax=256;
	lMax = ((int)(lMax / 1000)+1) * 1000;
	
	// qXgO̕\
	pDC->MoveTo( m_GraphRect.left, m_GraphRect.bottom );
	for(i=0;i<MAX_DENSITY;i++){
		lNum = (m_lHistogram[i] > lMax) ? lMax : m_lHistogram[i] ;
		pDC->MoveTo( m_GraphRect.left + i, m_GraphRect.bottom );
		pDC->LineTo( m_GraphRect.left + i, m_GraphRect.bottom - (lNum*(m_GraphRect.bottom-m_GraphRect.top)/lMax) );
	}

	strBuff.Format("%d", lMax);
	m_Max.SetWindowText(strBuff);

}

BOOL CHistgram::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	// ɎOɕ\
	SetWindowPos( &wndTopMost, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE );
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}
